from typing import Any
from typing import List
from typing import Set
from typing import Tuple

from . import *


class FModifierFunctionGenerator(FModifier):
    
    # Scale factor determining the maximum/minimum values
    amplitude: float
    
    # Type of built-in function to use
    function_type: str = 'SIN' # ['SIN', 'COS', 'TAN', 'SQRT', 'LN', 'SINC']
    
    # Scale factor determining the ‘speed’ of the function
    phase_multiplier: float
    
    # Constant factor to offset time by for function
    phase_offset: float
    
    # Values generated by this modifier are applied on top of the existing values instead of overwriting them
    use_additive: bool
    
    # Constant factor to offset values by
    value_offset: float

    @classmethod
    def bl_rna_get_subclass(cls, *args, **kwargs) -> Struct:
        ...

    @classmethod
    def bl_rna_get_subclass_py(cls, *args, **kwargs) -> Any:
        ...